library(gnlm)
library(repeated)

data <- read.table("aids.dat",skip=5,head=T)
attach(data)
y <- c(Month1,Month2,Month3)
wt <- y>0
y <- ifelse(y>0,y,1)
cens <- c(C1,C2,C3)
yy <- cbind(y,cens)
y1 <- c(Month2,Month3)
y0 <- c(Month1,Month2)
ly0 <- log(ifelse(y0,y0,1))
wt1 <- y1>0&y0>0
y1 <- ifelse(y1>0,y1,1)
yy1 <- cbind(y1,c(C2,C3))
treat <- as.factor(Treatment)

mu <- function(p,linear) exp(linear)
gnlr(yy,"Weibull",pmu=2.75,psh=0.4,mu=mu,linear=~1,wt=wt)
gnlr(yy,"extreme value",pmu=17.5,psh=-2,mu=mu,linear=~1,wt=wt)
gnlr(yy,"Weibull",pmu=c(2.75,0,0),psh=0.4,mu=mu,linear=~rep(treat,3),wt=wt)
gnlr(yy,"exponential",pmu=c(2.75,0,0),mu=mu,linear=~rep(treat,3),wt=wt)

gnlr3(yy,"extreme value",pmu=116,psh=0.396,pfam=0.009,mu=mu,wt=wt,
	linear=~1,stepmax=0.1)
gnlr3(yy,"extreme value",pmu=c(111,0.65,0.31),psh=0.5,pfam=0.0099,mu=mu,wt=wt,
	linear=~rep(treat,3),stepmax=1)

gnlr(yy1,"Weibull",pmu=2.75,psh=0.4,mu=mu,linear=~1,wt=wt1)
gnlr(yy1,"Weibull",pmu=c(2.75,0,0),psh=0.4,mu=mu,linear=~rep(treat,2),wt=wt1)
gnlr(yy1,"Weibull",pmu=c(2.6,0.4,0.1,0),psh=0.4,mu=mu,wt=wt1,
	linear=~rep(treat,2)+y0)
gnlr(yy1,"Weibull",pmu=c(2.6,0.4,0.1,0),psh=0.4,mu=mu,wt=wt1,
	linear=~rep(treat,2)+ly0)

resp <- cbind(Month1,Month2,Month3)
resp <- ifelse(resp==0,NA,resp)
censor <- cbind(C1,C2,C3)
resp <- restovec(resp,censor=censor)
mu <- function(p) p[1]*rep(1,102)
gar(resp,"exponential",mu=mu,preg=0,pdep=0.5,link="log")
gar(resp,"Weibull",mu=mu,preg=3,psh=1,pdep=0.9,link="log")
gar(resp,"gamma",mu=mu,preg=0,psh=1.5,pdep=0.5,link="log")
mut <- function(p) p[1]*rep(1,102)+p[2]*c(rep(0,32),rep(1,35),rep(0,35))+
	p[3]*c(rep(0,67),rep(1,35))
gar(resp,"exponential",mu=mut,preg=c(2,1.2,0.2),pdep=0.9,link="log")
gar(resp,"Weibull",mu=mut,preg=c(2,1.15,0.68),psh=1.6,pdep=0.9,link="log")
gar(resp,"gamma",mu=mut,preg=c(2,1.1,0.6),psh=1.8,pdep=0.9,link="log")
