library(gnlm)
library(event)

interf <- read.table("interfer.dat",skip=14,head=T)
attach(interf)
treat <- 2-treat
times <- read.list("intert.dat",skip=5,nline=1)
tt <- list()
birth <- vt <- censor <- gp <- ag <- tr <- id <- NULL
j <- 0
for(i in times){
	j <- j+1
	id <- c(id,rep(j,length(i)))
	tt <- c(tt,list(c(i[1],diff(i))))
	vt <- c(vt,i[1],diff(i))
	birth <- c(birth,log(1:length(i)))
	censor <- c(censor,rep(1,length(i)))
	censor[length(censor)] <- cens[j]
	tr <- c(tr,rep(treat[j],length(i)))
	ag <- c(ag,rep(age[j],length(i)))
	tmp <- rep(2+treat[j],length(i))
	tmp[1] <- treat[j]
	gp <- c(gp,tmp)}
tt <- restovec(tt,cens=cens)

mu <- function(p,linear) exp(linear)
gnlr(cbind(vt,censor),"exponential",mu=mu,linear=~1,pmu=6)
gnlr(cbind(vt,censor),"exponential",mu=mu,linear=~tr,pmu=c(6,0))
gnlr(cbind(vt,censor),"exponential",mu=mu,linear=~ag,pmu=c(6,0))
gnlr(cbind(vt,censor),"Weibull",mu=mu,linear=~1,pmu=6,psh=-0.1)
gnlr(cbind(vt,censor),"Weibull",mu=mu,linear=~tr,pmu=c(6,0),psh=-0.1)
gnlr(cbind(vt,censor),"Weibull",mu=mu,linear=~ag,pmu=c(6,0),psh=-0.1)
gnlr(cbind(vt,censor),"gamma",mu=mu,linear=~1,pmu=6,psh=-0.1)
gnlr(cbind(vt,censor),"gamma",mu=mu,linear=~tr,pmu=c(6,0),psh=-0.1)
gnlr(cbind(vt,censor),"gamma",mu=mu,linear=~ag,pmu=c(6,0),psh=-0.1)
gnlr(cbind(log(vt),censor),"normal",mu=mu,linear=~1,pmu=2,psh=1,delta=1/vt)
gnlr(cbind(log(vt),censor),"normal",mu=mu,linear=~tr,pmu=c(2,0),psh=1,
	delta=1/vt)
gnlr(cbind(log(vt),censor),"normal",mu=mu,linear=~ag,pmu=c(2,0),psh=1,
	delta=1/vt)
gnlr(cbind(log(vt),censor),"logistic",mu=mu,linear=~1,pmu=2,psh=1,delta=1/vt)
gnlr(cbind(log(vt),censor),"logistic",mu=mu,linear=~tr,pmu=c(2,0),psh=1,
	delta=1/vt)
gnlr(cbind(log(vt),censor),"logistic",mu=mu,linear=~ag,pmu=c(2,0),psh=1,
	delta=1/vt)
gnlr(cbind(log(vt),censor),"Cauchy",mu=mu,linear=~1,pmu=2,psh=-0.5,delta=1/vt)
gnlr(cbind(log(vt),censor),"Cauchy",mu=mu,linear=~tr,pmu=c(2,0),psh=-0.5,
	delta=1/vt)
gnlr(cbind(log(vt),censor),"Cauchy",mu=mu,linear=~ag,pmu=c(2,0),psh=-0.5,
	delta=1/vt)
gnlr(cbind(vt,censor),"exponential",mu=mu,linear=~birth,pmu=c(6,0))
gnlr(cbind(vt,censor),"exponential",mu=mu,linear=~tr+birth,pmu=c(6,0,0))
gnlr(cbind(vt,censor),"exponential",mu=mu,linear=~tr*birth,pmu=c(6,0,0,0))
gnlr(cbind(vt,censor),"exponential",mu=mu,linear=~ag+birth,pmu=c(6,0,0))
gnlr(cbind(vt,censor),"Weibull",mu=mu,linear=~birth,pmu=c(6,0),psh=-0.1)
gnlr(cbind(vt,censor),"Weibull",mu=mu,linear=~tr+birth,pmu=c(6,0,0),psh=-0.1)
gnlr(cbind(vt,censor),"Weibull",mu=mu,linear=~tr*birth,pmu=c(6,0,0,0),psh=-0.1)
gnlr(cbind(vt,censor),"Weibull",mu=mu,linear=~ag+birth,pmu=c(6,0,0),psh=-0.1)
gnlr(cbind(vt,censor),"gamma",mu=mu,linear=~birth,pmu=c(6,0),psh=-0.1)
gnlr(cbind(vt,censor),"gamma",mu=mu,linear=~tr+birth,pmu=c(6,0,0),psh=-0.1)
gnlr(cbind(vt,censor),"gamma",mu=mu,linear=~tr*birth,pmu=c(6,0,0,0),psh=-0.1)
gnlr(cbind(vt,censor),"gamma",mu=mu,linear=~ag+birth,pmu=c(6,0,0),psh=-0.1)

if(interactive()){
plot(km(tt,censor=cens,group=treat))
postscript("interfer.eps",height=5,width=5)
plot(km(vt,censor=censor,group=gp),main="",xlab="Days",
	ylab="Reinfection probability")
lines(seq(1,400,by=10),1-pexp(seq(1,400,by=10),exp(-6.1549-0.8089)))
lines(seq(1,400,by=10),1-pexp(seq(1,400,by=10),exp(-6.1549)),lty=2)
lines(seq(1,400,by=10),1-pexp(seq(1,400,by=10),
	exp(-6.1549-0.8089+0.9858*log(3))),lty=3)
lines(seq(1,400,by=10),1-pexp(seq(1,400,by=10),exp(-6.1549+0.9858*log(3))),
	lty=4)
#lines(seq(1,400,by=10),1-pexp(seq(1,400,by=10),exp(-6.1765-0.8306)))
#lines(seq(1,400,by=10),1-pexp(seq(1,400,by=10),exp(-6.1765)),lty=2)
#lines(seq(1,400,by=10),1-pexp(seq(1,400,by=10),
#	exp(-6.1765-0.8306+1.0102)),lty=3)
#lines(seq(1,400,by=10),1-pexp(seq(1,400,by=10),exp(-6.1765+1.0102)),lty=4)
legend(0,0.3,legend=c("First infection","Interferon","Placebo",
	"Subsequent infections","Interferon","Placebo"),
	lty=c("0","solid","dashed","0","dotted","4413"),bty="n")
}

print(ze <- kalsurv(tt,pinit=1.5,preg=6,dep="frailty"))
print(zeb <- kalsurv(tt,pinit=0.1,preg=6.5,pbirth=-1,dep="frailty"))
print(zet <- kalsurv(tt,pinit=1.5,preg=c(6,1),ccov=treat,dep="frailty"))
print(zetb <- kalsurv(tt,pinit=1.5,preg=c(6,1),pbirth=0,
	ccov=treat,dep="frailty"))

print(zw <- kalsurv(tt,pinit=1.5,preg=6,psh=1,intensity="Weibull",
	dep="frailty"))
print(zwb <- kalsurv(tt,pinit=1.5,preg=6,psh=1,
	pbirth=0,intensity="Weibull",dep="frailty"))
print(zwt <- kalsurv(tt,pinit=1.5,psh=1,preg=c(6,1),
	ccov=treat,intensity="Weibull",dep="frailty"))
print(zwtb <- kalsurv(tt,pinit=0.1,psh=1,pbirth=-1,
	preg=c(6,1),ccov=treat,intensity="Weibull",dep="frailty"))

print(zlnt <- kalsurv(tt,pinit=1,psh=3,preg=c(6,1),
	ccov=treat,intensity="log normal",dep="frailty"))

print(zllt <- kalsurv(tt,pinit=1,psh=3,preg=c(6,1),
	ccov=treat,intensity="log logistic",dep="frailty"))

print(zlct <- kalsurv(tt,pinit=1,psh=0.03,preg=c(6,1),
	ccov=treat,intensity="log Cauchy",dep="frailty"))

print(zei <- kalsurv(tt,pinit=1.5,preg=6,dep="independence"))
print(zee <- kalsurv(tt,pinit=1.5,pdep=0.9,preg=6,dep="serial",upd="event"))
print(zeeb <- kalsurv(tt,pinit=0.01,pdep=0.9,preg=6.5,
	pbirth=-1,dep="serial",upd="event"))
print(zem <- kalsurv(tt,pinit=1.5,pdep=0.9,preg=6,dep="serial",upd="Markov"))
print(zemb <- kalsurv(tt,pinit=0.1,pdep=0.5,preg=6.5,
	pbirth=-1,dep="serial",upd="Markov"))
print(zec <- kalsurv(tt,pinit=1.5,pdep=0.5,preg=6,dep="serial",upd="count"))
print(zeh <- kalsurv(tt,pinit=1.5,pdep=0.5,preg=6,
	dep="serial",upd="cumulated"))
print(zek <- kalsurv(tt,pinit=1.5,pdep=0.5,preg=6,dep="serial",upd="kalman"))
rm(zei,zee,zeeb,zem,zemb,zec,zeh,zek)

print(zeit <- kalsurv(tt,pinit=1.5,dep="independence",
	preg=c(6,1),ccov=treat))
print(zeitb <- kalsurv(tt,pinit=0.1,dep="independence",
	pbirth=-1,preg=c(6,1),ccov=treat))
print(zeet <- kalsurv(tt,pinit=1.5,pdep=0.5,upd="event",
	dep="serial",preg=c(6,1),ccov=treat))
print(zeetb <- kalsurv(tt,pinit=0.1,pdep=0.6,
	pbirth=-1,dep="serial",upd="event",preg=c(6,1),ccov=treat))
print(zemt <- kalsurv(tt,pinit=0.1,pdep=0.5,upd="Markov",
	dep="serial",preg=c(6,1),ccov=treat))
print(zemtb <- kalsurv(tt,pinit=0.01,pdep=0.5,
	pbirth=-1,dep="serial",upd="Markov",preg=c(6.5,1),ccov=treat))
print(zect <- kalsurv(tt,pinit=1.5,pdep=0.5,upd="count",
	dep="serial",preg=c(6,1),ccov=treat))
print(zectb <- kalsurv(tt,pinit=0.1,pdep=0.5,upd="count",
	dep="serial",pbirth=-1,preg=c(6,0),ccov=treat))
print(zeht <- kalsurv(tt,pinit=0.1,pdep=0.5,dep="serial",
	upd="cumulated",preg=c(6,0),ccov=treat))
print(zekt <- kalsurv(tt,pinit=0.1,pdep=0.5,upd="kalman",
	dep="serial",preg=c(6,0),ccov=treat))
rm(zeit,zeet,zeetb,zemt,zemtb,zect,zeht,zekt)

print(zeita <- kalsurv(tt,pinit=1.5,dep="independence",
	preg=c(6,1,0),ccov=~treat+age))
print(zeeta <- kalsurv(tt,pinit=1.5,pdep=0.5,
	dep="serial",upd="event",preg=c(6,1,0),ccov=~treat+age))
print(zemta <- kalsurv(tt,pinit=1.5,pdep=0.5,
	dep="serial",upd="Markov",preg=c(6,1,0),ccov=~treat+age))
print(zecta <- kalsurv(tt,pinit=1.5,pdep=0.5,
	dep="serial",upd="count",preg=c(6,1,0),ccov=~treat+age))
rm(zeita,zeeta,zemta,zecta)

print(zwi <- kalsurv(tt,pinit=1.5,preg=6,psh=1,
	dep="independence",intensity="Weibull"))
print(zwe <- kalsurv(tt,pinit=1.5,pdep=0.5,preg=6,psh=1,
	dep="serial",upd="event",intensity="Weibull"))
print(zweb <- kalsurv(tt,pinit=0.1,pdep=0.45,preg=6.5,psh=1,
	pbirth=-1.2,dep="serial",upd="event",intensity="Weibull"))
print(zwm <- kalsurv(tt,pinit=1.5,pdep=0.5,preg=6,psh=1,
	dep="serial",upd="Markov",intensity="Weibull"))
print(zwmb <- kalsurv(tt,pinit=0.01,pdep=0.5,preg=6.5,psh=1,
	pbirth=-1,dep="serial",upd="Markov",intensity="Weibull"))
print(zwc <- kalsurv(tt,pinit=1.5,pdep=0.5,preg=6,psh=1,
	dep="serial",upd="count",intensity="Weibull"))
print(zwh <- kalsurv(tt,pinit=1.5,pdep=0.5,preg=6,psh=1,
	dep="serial",upd="cumulated",intensity="Weibull"))
print(zwk <- kalsurv(tt,pinit=1.5,pdep=0.5,preg=6,psh=1,
	dep="serial",upd="kalman",intensity="Weibull"))
rm(zwi,zwe,zweb,zwm,zwmb,zwc,zwh,zwk)

print(zwit <- kalsurv(tt,pinit=0.1,psh=0.9,
	dep="independence",intensity="Weibull",preg=c(6,1),ccov=treat))
print(zwitb <- kalsurv(tt,pinit=0.1,psh=1,pbirth=0,
	dep="independence",intensity="Weibull",preg=c(6,1),ccov=treat))
print(zwet <- kalsurv(tt,pinit=1.5,pdep=0.5,psh=1,
	dep="serial",upd="event",intensity="Weibull",preg=c(6,1),ccov=treat))
print(zwetb <- kalsurv(tt,pinit=0.01,pdep=0.45,psh=1,dep="serial",
	pbirth=-1,upd="event",intensity="Weibull",preg=c(6,1),ccov=treat))
print(zwmt <- kalsurv(tt,pinit=1.5,pdep=0.1,psh=1,
	dep="serial",upd="Markov",intensity="Weibull",preg=c(6,1),ccov=treat))
print(zwmtb <- kalsurv(tt,pinit=0.1,pdep=0.55,psh=1,dep="serial",
	pbirth=-1,upd="Markov",intensity="Weibull",preg=c(6,1),ccov=treat))
print(zwct <- kalsurv(tt,pinit=0.5,pdep=0.5,psh=1,
	dep="serial",upd="count",intensity="Weibull",preg=c(6,1),ccov=treat))
print(zwht <- kalsurv(tt,pinit=1.5,pdep=0.5,psh=1,dep="serial",
	upd="cumulated",intensity="Weibull",preg=c(6,1),ccov=treat))
print(zwkt <- kalsurv(tt,pinit=1.5,pdep=0.5,psh=1,
	dep="serial",upd="kalman",intensity="Weibull",preg=c(6,1),ccov=treat))
rm(zwit,zwet,zwetb,zwmt,zwmtb,zwct,zwht,zwkt)

print(zwita <- kalsurv(tt,pinit=0.1,psh=1,dep="independence",
	intensity="Weibull",preg=c(5.4,1,0),ccov=~treat+age))
print(zweta <- kalsurv(tt,pinit=0.1,pdep=0.5,psh=1,dep="serial",
	upd="event",intensity="Weibull",preg=c(6,1,0),ccov=~treat+age))
print(zwmta <- kalsurv(tt,pinit=0.1,pdep=0.1,psh=1,dep="serial",
	upd="Markov",intensity="Weibull",preg=c(6,1,0),ccov=~treat+age))
rm(zwita,zweta,zwmta)

print(zlne <- kalsurv(tt,pinit=0.5,pdep=0.5,preg=6,psh=3,
	dep="serial",upd="event",intensity="log normal"))
print(zlnet <- kalsurv(tt,pinit=0.1,pdep=0.83,psh=3,dep="serial",
	upd="serial",intensity="log normal",preg=c(6,1.5),ccov=treat))
print(zlnm <- kalsurv(tt,pinit=1,pdep=0.5,preg=6,psh=3,
	dep="serial",upd="Markov",intensity="log normal"))
print(zlnmt <- kalsurv(tt,pinit=1,pdep=0.9,psh=3,dep="serial",
	upd="Markov",intensity="log normal",preg=c(6,1),ccov=treat))
rm(zlne,zlnet,zlnm,zlnmt)

print(zedi <- kalsurv(tt,pinit=0.1,preg=5,dep="independence",dens=T))
print(zedm <- kalsurv(tt,pinit=0.1,pdep=0.8,preg=6,
	dep="serial",upd="Markov",dens=T))
print(zedit <- kalsurv(tt,pinit=0.1,dep="independence",
	preg=c(5,1),ccov=treat,dens=T))
print(zedmt <- kalsurv(tt,pinit=0.1,pdep=0.95,
	dep="serial",upd="Markov",preg=c(5,1),ccov=treat,dens=T))
rm(zedi,zedm,zedit,zedmt)

print(zwdi <- kalsurv(tt,pinit=0.001,preg=6,psh=1,
	dep="independence",intensity="Weibull",dens=T))
print(zwdm <- kalsurv(tt,pinit=0.1,pdep=0.5,preg=6,psh=1,
	dep="serial",upd="Markov",intensity="Weibull",dens=T))
print(zwdit <- kalsurv(tt,pinit=0.1,psh=1,dep="independence",
	intensity="Weibull",preg=c(5,0.4),ccov=treat,dens=T))
print(zwdmt <- kalsurv(tt,pinit=1.5,pdep=0.5,psh=1,dep="serial",
	upd="Markov",intensity="Weibull",preg=c(6,1),ccov=treat,dens=T))
rm(zwdi,zwdm,zwdit,zwdmt)

cn <- rep(1,length(response(tt)))
cn[cumsum(nobs(tt))] <- cens
y <- cbind(response(tt),cn)
gnlr(y,"exponential",pmu=350,delta=cn)
gnlr(y,"Weibull",pmu=350,pshape=0,delta=cn)
gnlr(y,"gamma",pmu=350,pshape=0,delta=cn)
tr <- treat[covind(tt)]
ag <- age[covind(tt)]
mu <- function(p) exp(p[1]+p[2]*tr)
gnlr(y,"exponential",pmu=c(8,-1),mu=mu,delta=cn)
gnlr(y,"Weibull",pmu=c(8,-1),pshape=0,mu=mu,delta=cn)
birth <- log(sequence(nobs(tt)))
mu <- function(p) exp(p[1]+p[2]*tr+p[3]*birth)
gnlr(y,"exponential",pmu=c(8,-1,0),mu=mu,delta=cn)
gnlr(y,"Weibull",pmu=c(8,-1,0),pshape=0,mu=mu,delta=cn)
mu <- function(p) exp(p[1]+p[2]*tr+p[3]*ag+p[4]*birth)
gnlr(y,"exponential",pmu=c(8,-1,0,0),mu=mu,delta=cn)
gnlr(y,"Weibull",pmu=c(8,-1,0,0),pshape=0,mu=mu,delta=cn)

y <- pp(vt,cens=censor)
ptr <- tccov(vt,treat,id)
page <- tccov(vt,age,id)
tp <- tpast(vt)
n <- bp(vt,id)
detach(interf)
rm(id,tmp,i,j,vt,censor,interf,times,treat,birth,gp,ag,tr,id)

# exponential
ehr(y,plambda=-5)
ehr(y,plambda=c(-5.8,-1),lambda=~ptr)
ehr(y,plambda=c(-5.8,0.4),lambda=~n)
ehr(y,plambda=c(-5.8,-1,0.3),lambda=~ptr+n)
ehr(y,plambda=c(-6,-1,0.3,0.5),lambda=~ptr*n)
ehr(y,plambda=c(-5.8,0.4),lambda=~log(n+1))
ehr(y,plambda=c(-5.8,-1,0.3),lambda=~ptr+log(n+1))
ehr(y,plambda=c(-6,-1,0.3,0.5),lambda=~ptr*log(n+1))
ehr(y,plambda=c(-5.8,-1,0.3),lambda=~ptr+(n>0))
ehr(y,plambda=c(-6,-1,0.3,0.5),lambda=~ptr*I(n>0))
ehr(y,plambda=c(-5.8,-0.02,0.3),lambda=~page+n)
ehr(y,plambda=c(-5.8,-0.02,0.3),lambda=~page+log(n+1))
# Weibull
ehr(y,plambda=c(-5.8,-0.1),lambda=~log(tp))
ehr(y,plambda=c(-5.85,0,-1.14),lambda=~log(tp)+ptr)
ehr(y,plambda=c(-6.2,-0.05,0.4),lambda=~log(tp)+n)
ehr(y,plambda=c(-6.2,-0.05,-1,0.3),lambda=~log(tp)+ptr+n)
ehr(y,plambda=c(-6.2,-0.05,-1,0.3,0.5),lambda=~log(tp)+ptr*n)
ehr(y,plambda=c(-6.1,0,0.4),lambda=~log(tp)+log(n+1))
ehr(y,plambda=c(-6.2,-0.05,-1,0.3),lambda=~log(tp)+ptr+log(n+1))
ehr(y,plambda=c(-6.2,-0.05,-1,0.3,0.5),lambda=~log(tp)+ptr*log(n+1))
ehr(y,plambda=c(-6.1,-0.01,-0.025,0.4),lambda=~log(tp)+page+n)
ehr(y,plambda=c(-6.1,-0.01,-0.025,0.4),lambda=~log(tp)+page+log(n+1))
# extreme value
ehr(y,plambda=c(-5.8,-0.01),lambda=~tp)
ehr(y,plambda=c(-5.8,-0.01,-1),lambda=~tp+ptr)
