library(event)
library(repeated)
library(gnlm)

data <- scan("snoq.dat")
prec <- y <- NULL
j <- 0
for(i in 1:36){
      y <- rbind(y,as.numeric(data[(1+j):(31+j)]>0))
      prec <- rbind(prec,data[(1+j):(31+j)])
      j <- j+(365+((i%%4)==1))}

if(interactive()){
postscript("snoq.eps",height=5)
par(mfrow=c(1,2),font.main=1)
cprocess(events=y,xlab="Days",ylab="Wet days")
cprocess(events=prec/100,xlab="Days",ylab="Precipitation (in)")
}

mu <- function(p) array(rep(p[1:2],rep(36,2)), c(36,2))
print(z <- hidden(y,dist="Bernoulli", cmu=mu, pcmu=c(0.1,1),
	pgamma=matrix(c(0.9,0.2,0.1,0.8),ncol=2)))
mu <- function(p) array(rep(c(-35,p[1]),rep(36,2)), c(36,2))
print(z <- hidden(y,dist="Bernoulli", cmu=mu, pcmu=1,
	pgamma=matrix(c(0.9,0.2,0.1,0.8),ncol=2)))
mu <- function(p) array(rep(c(p[1],35),rep(36,2)), c(36,2))
print(z <- hidden(y,dist="Bernoulli", cmu=mu, pcmu=1,
	pgamma=matrix(c(0.9,0.2,0.1,0.8),ncol=2)))

if(interactive()){
#postscript("snoq.eps")
par(mfrow=c(6,6),font.main=1)
plot(1:31,z$filt[1,covind(z)==1],type="l",xlab="",ylab=expression(pi[1]),
	main="1948",ylim=c(0,1))
for(i in 2:6)
plot(1:31,z$filt[1,covind(z)==i],type="l",xlab="",ylab="",
	main=paste(1947+i),ylim=c(0,1))
plot(1:31,z$filt[1,covind(z)==7],type="l",xlab="",ylab=expression(pi[1]),
	main=1954,ylim=c(0,1))
for(i in 8:12)
plot(1:31,z$filt[1,covind(z)==i],type="l",xlab="",ylab="",
	main=paste(1947+i),ylim=c(0,1))
plot(1:31,z$filt[1,covind(z)==13],type="l",xlab="",ylab=expression(pi[1]),
	main=1960,ylim=c(0,1))
for(i in 14:18)
plot(1:31,z$filt[1,covind(z)==i],type="l",xlab="",ylab="",
	main=paste(1947+i),ylim=c(0,1))
plot(1:31,z$filt[1,covind(z)==19],type="l",xlab="",ylab=expression(pi[1]),
	main=1966,ylim=c(0,1))
for(i in 20:24)
plot(1:31,z$filt[1,covind(z)==i],type="l",xlab="",ylab="",
	main=paste(1947+i),ylim=c(0,1))
plot(1:31,z$filt[1,covind(z)==13],type="l",xlab="",ylab=expression(pi[1]),
	main=1972,ylim=c(0,1))
for(i in 26:30)
plot(1:31,z$filt[1,covind(z)==i],type="l",xlab="",ylab="",
	main=paste(1947+i),ylim=c(0,1))
plot(1:31,z$filt[1,covind(z)==19],type="l",xlab="Days",ylab=expression(pi[1]),
	main=1978,ylim=c(0,1))
for(i in 32:36)
plot(1:31,z$filt[1,covind(z)==i],type="l",xlab="Days",ylab="",
	main=paste(1947+i),ylim=c(0,1))
}

fmr(as.vector(t(y)),dist="Poisson",censor="left",pmu=1,pmix=0)
fmr(cbind(as.vector(t(y)),1-as.vector(t(y))),dist="binomial",censor="left",
	pmu=1.4,pmix=-0.2)

py <- NULL
j <- 0
for(i in 2:36){
      j <- j+(365+((i%%4)==1))
      py <- c(py,data[j+1])}
py <- cbind(c(1,as.numeric(py>0)),y[,1:30])
yy <- NULL
j <- 0
for(i in 1:36){
      yy <- rbind(yy,data[(1+j):(31+j)])
      j <- j+(365+((i%%4)==1))}
yy <- ifelse(yy>0,yy,0.5)
mu <- function(p) array(rep(p[1:2],rep(36,2)), c(36,2))
print(z <- hidden(yy,dist="gamma", cmu=mu, pcmu=c(1,1), psh=1,
	pgamma=matrix(c(0.9,0.2,0.1,0.8),ncol=2),delta=0.5))

yy <- as.vector(t(yy))
py <- as.vector(t(py))
cens <- ifelse(yy>0.5,1,-1)
lyy <- log(yy)
mu <- function(p) exp(p[1])
gnlr(yy,dist="gamma",mu=mu,pmu=1,psh=0,delta=0.5)
gnlr(cbind(yy,cens),dist="gamma",mu=mu,pmu=1,psh=0,delta=0.5)
gnlr(cbind(yy,cens),dist="Weibull",mu=mu,pmu=1,psh=0,delta=0.5)
gnlr(cbind(yy,cens),dist="inverse Gauss",mu=mu,pmu=4,psh=-2,delta=0.5)
#gnlr(cbind(yy,cens),dist="Pareto",mu=mu,pmu=10,psh=0.1,delta=0.5)
gnlr(cbind(lyy,cens),dist="normal",pmu=1,psh=0,delta=0.5/yy)
gnlr(cbind(lyy,cens),dist="logistic",pmu=1,psh=0,delta=0.5/yy)
gnlr(cbind(lyy,cens),dist="Laplace",pmu=1,psh=0,delta=0.5/yy)
gnlr(cbind(lyy,cens),dist="Cauchy",pmu=1,psh=0,delta=0.5/yy)

fmr(cbind(yy,cens),dist="gamma",censor="left",mu=mu,pmu=1,psh=0,pmix=0,
	delta=0.5)
fmr(cbind(yy,cens),dist="Weibull",censor="left",mu=mu,pmu=1,psh=0,pmix=0,
	delta=0.5)
fmr(cbind(yy,cens),dist="inverse Gauss",censor="left",mu=mu,pmu=1,psh=0,
	pmix=0,delta=0.5)
fmr(cbind(yy,cens),dist="Pareto",censor="left",mu=mu,pmu=1,psh=0,pmix=0,
	delta=0.5)
fmr(cbind(lyy,cens),dist="normal",censor="left",pmu=1,psh=0,pmix=0,
	delta=0.5/yy)
fmr(cbind(lyy,cens),dist="logistic",censor="left",pmu=1,psh=0,pmix=0,
	delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Laplace",censor="left",pmu=1,psh=0,pmix=0,
	delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Cauchy",censor="left",pmu=1,psh=0,pmix=0,
	delta=0.5/yy)

glm(yy>0.5~py,family=binomial)
exp(-0.4367)/(1+exp(-0.4367))
exp(-0.4367+2.069)/(1+exp(-0.4367+2.069))
mix <- function(p) p[1]+py*p[2]
fmr(cbind(yy,cens),dist="gamma",censor="left",mu=mu,pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5)
fmr(cbind(yy,cens),dist="Weibull",censor="left",mu=mu,pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5)
fmr(cbind(yy,cens),dist="inverse Gauss",censor="left",mu=mu,pmu=1,psh=0,
	pmix=c(0,0), mix=mix,delta=0.5)
fmr(cbind(yy,cens),dist="Pareto",censor="left",mu=mu,pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5)
fmr(cbind(lyy,cens),dist="normal",censor="left",pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="logistic",censor="left",pmu=1,psh=0,
	pmix=c(0,0), mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Laplace",censor="left",pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Cauchy",censor="left",pmu=1,psh=0,pmix=c(0,0),
	mix=mix,delta=0.5/yy)

mu <- function(p) exp(p[1]+py*p[2])
mu2 <- function(p) p[1]+py*p[2]
fmr(cbind(yy,cens),dist="gamma",censor="left",mu=mu,pmu=c(1,0),psh=0,
	pmix=c(0,0),mix=mix,delta=0.5)
fmr(cbind(yy,cens),dist="Weibull",censor="left",mu=mu,pmu=c(1,0),psh=0,
	pmix=c(0,0),mix=mix,delta=0.5)
exp(2.9521)
exp(2.9521+0.6755)
exp(-0.3486)/(1+exp(-0.3486))
exp(-0.3486+2.1845)/(1+exp(-0.3486+2.1845))
exp(-0.2144)
fmr(cbind(yy,cens),dist="inverse Gauss",censor="left",mu=mu,pmu=c(1,0),psh=0,
	pmix=c(0,0), mix=mix,delta=0.5)
fmr(cbind(yy,cens),dist="Pareto",censor="left",mu=mu,pmu=c(1,0),psh=0,
	pmix=c(0,0),mix=mix,delta=0.5)
fmr(cbind(lyy,cens),dist="normal",censor="left",mu=mu2,pmu=c(1,0),psh=0,
	pmix=c(0,0),mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="logistic",censor="left",mu=mu2,pmu=c(1,0),psh=0,
	pmix=c(0,0), mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Laplace",censor="left",mu=mu2,pmu=c(2.7,0.6),psh=0.2,
	pmix=c(-0.4,2.1),mix=mix,delta=0.5/yy)
fmr(cbind(lyy,cens),dist="Cauchy",censor="left",mu=mu2,pmu=c(1,0),psh=0,
	pmix=c(0,0),mix=mix,delta=0.5/yy)

if(interactive()){
py <- NULL
j <- 0
for(i in 2:36){
      j <- j+(365+((i%%4)==1))
      py <- c(py,data[j+1])}
yy <- NULL
j <- 0
for(i in 1:36){
      yy <- rbind(yy,data[(1+j):(31+j)])
      j <- j+(365+((i%%4)==1))}
py <- cbind(c(NA,py),yy)
}
