library(gnlm)

data <- read.table("leukemia.dat",skip=7)
colnames(data) <- c("relapse","cenr","death","cend")
attach(data)

gnlr(cbind(death[death>0],cenr[death>0]),"Pareto",pmu=100,psh=1)
gnlr(cbind(death[death>0],cenr[death>0]),"gamma",pmu=100,psh=1)
gnlr(cbind(death[death>0],cenr[death>0]),"Weibull",pmu=100,psh=0)
gnlr3(cbind(death[death>0],cenr[death>0]),"Burr",pmu=100,psh=1,pfam=1)
mu <- function(p,linear) exp(linear)
gnlr3(cbind(death[death>0],cenr[death>0]),"Burr",mu=mu,pmu=c(6,0),psh=1,
	linear=~relapse[death>0],pfam=1)
gnlr3(cbind(death[death>0],cenr[death>0]),"Burr",pmu=100,psh=c(1,0),
	shape=~relapse[death>0],pfam=1)
gnlr3(cbind(death[death>0],cenr[death>0]),"Burr",pmu=100,psh=1,
	fam=~relapse[death>0],pfam=c(1,0))
